#include <QApplication>
#include <QWidget>
#include <QTimer>
#include <QLabel>
#include <QPixmap>
#include "simu.h"




#include <QRandomGenerator>

Simulation::Simulation(QLabel *fahrstuhlLabel, QObject *parent)
    : QObject(parent), fahrstuhlLabel(fahrstuhlLabel),aktuelleTemperatur(20.0), zustand(NACH_OBEN)

{
    // Timer für Updates
    timer = new QTimer(this);
    connect(timer, &QTimer::timeout, this, &Simulation::aktualisieren);


}


Simulation::~Simulation()
{
}

void Simulation::start()
{
    timer->start(1000); // Aktualisierung alle 1 Sekunde
}

void Simulation::aktualisieren()
{

    //fahrstuhlLabel->move(fahrstuhlLabel->x(), fahrstuhlLabel->y() - 85);
    //fahrstuhlLabel->move(fahrstuhlLabel->x(), fahrstuhlLabel->y() - 85);
    switch (zustand)
    {
    case NACH_OBEN:
        // Fahrstuhl nach oben bewegen
        fahrstuhlLabel->move(fahrstuhlLabel->x(), fahrstuhlLabel->y() - 295);

        if (lichtSensorAktiv(4))
        {
            zustand = WARTE_GEWICHT;
        }
        break;

    case WARTE_GEWICHT:
        if (gewichtSchwelleÜberschritten())
        {
            zustand = ZU_WASSER;
        }
        break;

    case ZU_WASSER:
        fahrstuhlLabel->move(fahrstuhlLabel->x() - (-90), fahrstuhlLabel->y() - 10); // Zu Position 1
        zustand = WASSER_ERHITZEN;
        break;

    case WASSER_ERHITZEN:
        if (temperaturErreicht())
        {
            zustand = WASSER_AUSGEBEN;
        }
        break;

    case WASSER_AUSGEBEN:
        // Wasserausgabe
        // ...
        zustand = NACH_LINKS;
        break;

    case NACH_LINKS:
        fahrstuhlLabel->move(fahrstuhlLabel->x() - 90, fahrstuhlLabel->y()); // Zu Position 1
        zustand = ZURUECK_START;
        break;


    case ZURUECK_START:
        fahrstuhlLabel->move(fahrstuhlLabel->x(), fahrstuhlLabel->y() + 305);
        zustand = NACH_RECHTS;
        break;

    case NACH_RECHTS:
        fahrstuhlLabel->move(fahrstuhlLabel->x() - (-90), fahrstuhlLabel->y()); // Zu Position 1
        zustand = NACH_Oben;
        break;

    case NACH_Oben:
        fahrstuhlLabel->move(fahrstuhlLabel->x(), fahrstuhlLabel->y() - 80);
        zustand = ZU_ENDE;
        break;

    case ZU_ENDE:
        fahrstuhlLabel->move(fahrstuhlLabel->x(), fahrstuhlLabel->y());
        break;
    }
}


// Lichtsensor Implementierung
bool Simulation::lichtSensorAktiv(int etage)
{

    // Simulierte Lichtsensor-Logik
    // Ersetzen Sie dies durch die tatsächliche Schnittstelle Ihres Sensors
    // Beispiel: Rückgabe true, wenn die Lichtintensität größer als 0 ist
    int lichtIntensitaet = QRandomGenerator::global()->bounded(10); // Simuliert Lichtintensität zwischen 0 und 10
    return lichtIntensitaet > 0;
}

// Gewichtssensor Implementierung
bool Simulation::gewichtSchwelleÜberschritten()
{
    // Simulierte Gewichtssensor-Logik
    // Ersetzen Sie dies durch die tatsächliche Schnittstelle Ihres Sensors
    // Beispiel: Rückgabe true, wenn das Gewicht über 50g ist
    //int gemessenesGewicht = QRandomGenerator::global()->bounded(300); // Simuliert ein Gewicht zwischen 0 und 300g
    //return gemessenesGewicht > 50;


    if (aktuellesGewicht < Gewichtsschwelle)
    {
        aktuellesGewicht += 40.0;
    }
    return aktuellesGewicht >= Gewichtsschwelle;
}

// Temperatursensor Implementierung
bool Simulation::temperaturErreicht()
{
    if (aktuelleTemperatur < zielTemperatur)
    {
        aktuelleTemperatur += 10.0;
    }
    return aktuelleTemperatur >= zielTemperatur;
}


